diff --git a/doc/guides/nics/features/bnxt.ini b/doc/guides/nics/features/bnxt.ini
index afb5414b49..ac682c5779 100644
--- a/doc/guides/nics/features/bnxt.ini
+++ b/doc/guides/nics/features/bnxt.ini
@@ -57,7 +57,7 @@ Perf doc             = Y
 
 [rte_flow items]
 any                  = Y
-eth                  = Y
+eth                  = P
 ipv4                 = Y
 ipv6                 = Y
 gre                  = Y
@@ -71,7 +71,7 @@ represented_port     = Y
 tcp                  = Y
 udp                  = Y
 vf                   = Y
-vlan                 = Y
+vlan                 = P
 vxlan                = Y
 
 [rte_flow actions]
diff --git a/doc/guides/nics/features/cxgbe.ini b/doc/guides/nics/features/cxgbe.ini
index f674803ec4..f9912390fb 100644
--- a/doc/guides/nics/features/cxgbe.ini
+++ b/doc/guides/nics/features/cxgbe.ini
@@ -36,7 +36,7 @@ x86-64               = Y
 Usage doc            = Y
 
 [rte_flow items]
-eth                  = Y
+eth                  = P
 ipv4                 = Y
 ipv6                 = Y
 pf                   = Y
@@ -44,7 +44,7 @@ phy_port             = Y
 tcp                  = Y
 udp                  = Y
 vf                   = Y
-vlan                 = Y
+vlan                 = P
 
 [rte_flow actions]
 count                = Y
diff --git a/doc/guides/nics/features/dpaa2.ini b/doc/guides/nics/features/dpaa2.ini
index 4c06841a87..09ce66c788 100644
--- a/doc/guides/nics/features/dpaa2.ini
+++ b/doc/guides/nics/features/dpaa2.ini
@@ -31,7 +31,7 @@ ARMv8                = Y
 Usage doc            = Y
 
 [rte_flow items]
-eth                  = Y
+eth                  = P
 gre                  = Y
 icmp                 = Y
 ipv4                 = Y
@@ -41,7 +41,7 @@ raw                  = Y
 sctp                 = Y
 tcp                  = Y
 udp                  = Y
-vlan                 = Y
+vlan                 = P
 
 [rte_flow actions]
 drop                 = Y
diff --git a/doc/guides/nics/features/e1000.ini b/doc/guides/nics/features/e1000.ini
index e4bdef6da9..a9cbed1c3c 100644
--- a/doc/guides/nics/features/e1000.ini
+++ b/doc/guides/nics/features/e1000.ini
@@ -31,7 +31,7 @@ x86-32               = Y
 x86-64               = Y
 
 [rte_flow items]
-eth                  = Y
+eth                  = P
 ipv4                 = Y
 ipv6                 = Y
 raw                  = Y
diff --git a/doc/guides/nics/features/enic.ini b/doc/guides/nics/features/enic.ini
index 61bec4910e..6dbea9f36e 100644
--- a/doc/guides/nics/features/enic.ini
+++ b/doc/guides/nics/features/enic.ini
@@ -40,7 +40,7 @@ Usage doc            = Y
 
 [rte_flow items]
 ecpri                = Y
-eth                  = Y
+eth                  = P
 geneve               = Y
 geneve_opt           = Y
 gtp                  = Y
@@ -52,7 +52,7 @@ raw                  = Y
 sctp                 = Y
 tcp                  = Y
 udp                  = Y
-vlan                 = Y
+vlan                 = P
 vxlan                = Y
 
 [rte_flow actions]
diff --git a/doc/guides/nics/features/hinic.ini b/doc/guides/nics/features/hinic.ini
index 9f6f0ebf3a..ada6607fe9 100644
--- a/doc/guides/nics/features/hinic.ini
+++ b/doc/guides/nics/features/hinic.ini
@@ -40,7 +40,7 @@ ARMv8                = Y
 
 [rte_flow items]
 any                  = Y
-eth                  = Y
+eth                  = P
 icmp                 = Y
 icmp6                = Y
 ipv4                 = Y
diff --git a/doc/guides/nics/features/hns3.ini b/doc/guides/nics/features/hns3.ini
index 405b94f05c..338b4e6864 100644
--- a/doc/guides/nics/features/hns3.ini
+++ b/doc/guides/nics/features/hns3.ini
@@ -51,7 +51,7 @@ Linux                = Y
 ARMv8                = Y
 
 [rte_flow items]
-eth                  = Y
+eth                  = P
 geneve               = Y
 icmp                 = Y
 ipv4                 = Y
@@ -60,7 +60,7 @@ nvgre                = Y
 sctp                 = Y
 tcp                  = Y
 udp                  = Y
-vlan                 = Y
+vlan                 = P
 vxlan                = Y
 vxlan_gpe            = Y
 
diff --git a/doc/guides/nics/features/i40e.ini b/doc/guides/nics/features/i40e.ini
index dd18fec217..6e141de326 100644
--- a/doc/guides/nics/features/i40e.ini
+++ b/doc/guides/nics/features/i40e.ini
@@ -54,7 +54,7 @@ Power8               = Y
 [rte_flow items]
 ah                   = Y
 esp                  = Y
-eth                  = Y
+eth                  = P
 gre                  = Y
 gtpc                 = Y
 gtpu                 = Y
@@ -69,7 +69,7 @@ sctp                 = Y
 tcp                  = Y
 udp                  = Y
 vf                   = Y
-vlan                 = Y
+vlan                 = P
 vxlan                = Y
 
 [rte_flow actions]
diff --git a/doc/guides/nics/features/iavf.ini b/doc/guides/nics/features/iavf.ini
index 01f514239e..c6694a1a94 100644
--- a/doc/guides/nics/features/iavf.ini
+++ b/doc/guides/nics/features/iavf.ini
@@ -40,7 +40,7 @@ ah                   = Y
 arp_eth_ipv4         = Y
 ecpri                = Y
 esp                  = Y
-eth                  = Y
+eth                  = P
 gre                  = Y
 gtpc                 = Y
 gtpu                 = Y
@@ -57,7 +57,7 @@ ppp                  = Y
 sctp                 = Y
 tcp                  = Y
 udp                  = Y
-vlan                 = Y
+vlan                 = P
 
 [rte_flow actions]
 count                = Y
diff --git a/doc/guides/nics/features/ice.ini b/doc/guides/nics/features/ice.ini
index 7861790a51..0bd2f2d7b2 100644
--- a/doc/guides/nics/features/ice.ini
+++ b/doc/guides/nics/features/ice.ini
@@ -53,7 +53,7 @@ ah                   = Y
 any                  = Y
 arp_eth_ipv4         = Y
 esp                  = Y
-eth                  = Y
+eth                  = P
 gtpu                 = Y
 gtp_psc              = Y
 icmp                 = Y
@@ -71,7 +71,7 @@ raw                  = Y
 sctp                 = Y
 tcp                  = Y
 udp                  = Y
-vlan                 = Y
+vlan                 = P
 vxlan                = Y
 
 [rte_flow actions]
diff --git a/doc/guides/nics/features/igc.ini b/doc/guides/nics/features/igc.ini
index f2c6fa28ad..b5deea3f61 100644
--- a/doc/guides/nics/features/igc.ini
+++ b/doc/guides/nics/features/igc.ini
@@ -35,7 +35,7 @@ Linux                = Y
 x86-64               = Y
 
 [rte_flow items]
-eth                  = Y
+eth                  = P
 ipv4                 = Y
 ipv6                 = Y
 tcp                  = Y
diff --git a/doc/guides/nics/features/ipn3ke.ini b/doc/guides/nics/features/ipn3ke.ini
index defc39f525..1f6b780273 100644
--- a/doc/guides/nics/features/ipn3ke.ini
+++ b/doc/guides/nics/features/ipn3ke.ini
@@ -47,13 +47,13 @@ x86-32               = Y
 x86-64               = Y
 
 [rte_flow items]
-eth                  = Y
+eth                  = P
 ipv4                 = Y
 mpls                 = Y
 nvgre                = Y
 tcp                  = Y
 udp                  = Y
-vlan                 = Y
+vlan                 = P
 vxlan                = Y
 
 [rte_flow actions]
diff --git a/doc/guides/nics/features/ixgbe.ini b/doc/guides/nics/features/ixgbe.ini
index c5333d1142..e5cef81f9a 100644
--- a/doc/guides/nics/features/ixgbe.ini
+++ b/doc/guides/nics/features/ixgbe.ini
@@ -56,7 +56,7 @@ x86-32               = Y
 x86-64               = Y
 
 [rte_flow items]
-eth                  = Y
+eth                  = P
 e_tag                = Y
 fuzzy                = Y
 ipv4                 = Y
@@ -66,7 +66,7 @@ raw                  = Y
 sctp                 = Y
 tcp                  = Y
 udp                  = Y
-vlan                 = Y
+vlan                 = P
 vxlan                = Y
 
 [rte_flow actions]
diff --git a/doc/guides/nics/features/mlx4.ini b/doc/guides/nics/features/mlx4.ini
index 82f6f0bc0b..03f59a5f8b 100644
--- a/doc/guides/nics/features/mlx4.ini
+++ b/doc/guides/nics/features/mlx4.ini
@@ -38,11 +38,11 @@ x86-64               = Y
 Usage doc            = Y
 
 [rte_flow items]
-eth                  = Y
+eth                  = P
 ipv4                 = Y
 tcp                  = Y
 udp                  = Y
-vlan                 = Y
+vlan                 = P
 
 [rte_flow actions]
 drop                 = Y
diff --git a/doc/guides/nics/features/mvpp2.ini b/doc/guides/nics/features/mvpp2.ini
index 1bcf74875e..653c9d08cb 100644
--- a/doc/guides/nics/features/mvpp2.ini
+++ b/doc/guides/nics/features/mvpp2.ini
@@ -24,13 +24,13 @@ ARMv8                = Y
 Usage doc            = Y
 
 [rte_flow items]
-eth                  = Y
+eth                  = P
 ipv4                 = Y
 ipv6                 = Y
 raw                  = Y
 tcp                  = Y
 udp                  = Y
-vlan                 = Y
+vlan                 = P
 
 [rte_flow actions]
 drop                 = Y
diff --git a/doc/guides/nics/features/tap.ini b/doc/guides/nics/features/tap.ini
index b4a356e5d5..f26355e57f 100644
--- a/doc/guides/nics/features/tap.ini
+++ b/doc/guides/nics/features/tap.ini
@@ -27,12 +27,12 @@ x86-64               = Y
 Usage doc            = Y
 
 [rte_flow items]
-eth                  = Y
+eth                  = P
 ipv4                 = Y
 ipv6                 = Y
 tcp                  = Y
 udp                  = Y
-vlan                 = Y
+vlan                 = P
 
 [rte_flow actions]
 drop                 = Y
diff --git a/doc/guides/nics/features/txgbe.ini b/doc/guides/nics/features/txgbe.ini
index 22c74ba9e3..e21083052c 100644
--- a/doc/guides/nics/features/txgbe.ini
+++ b/doc/guides/nics/features/txgbe.ini
@@ -53,7 +53,7 @@ x86-32               = Y
 x86-64               = Y
 
 [rte_flow items]
-eth                  = Y
+eth                  = P
 e_tag                = Y
 fuzzy                = Y
 ipv4                 = Y
@@ -63,7 +63,7 @@ raw                  = Y
 sctp                 = Y
 tcp                  = Y
 udp                  = Y
-vlan                 = Y
+vlan                 = P
 vxlan                = Y
 
 [rte_flow actions]